/*
  Copyright (C) 2021 Arm Limited or its affiliates. All rights reserved.

  SPDX-License-Identifier: Apache-2.0

  Licensed under the Apache License, Version 2.0 (the License); you may
  not use this file except in compliance with the License.
  You may obtain a copy of the License at

  www.apache.org/licenses/LICENSE-2.0

  Unless required by applicable law or agreed to in writing, software
  distributed under the License is distributed on an AS IS BASIS, WITHOUT
  WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  See the License for the specific language governing permissions and
  limitations under the License.
*/

#ifndef IR_UTILS_H
#define IR_UTILS_H

// #include "absl/memory/memory.h"
#include "mlir/Dialect/Quant/QuantOps.h"
#include "mlir/Dialect/Quant/QuantTypes.h"
#include "mlir/IR/AffineMap.h"                    // from @llvm-project
#include "mlir/IR/Attributes.h"                   // from @llvm-project
#include "mlir/IR/BlockAndValueMapping.h"         // from @llvm-project
#include "mlir/IR/Builders.h"                     // from @llvm-project
#include "mlir/IR/Location.h"                     // from @llvm-project
#include "mlir/IR/MLIRContext.h"                  // from @llvm-project
#include "mlir/IR/Operation.h"                    // from @llvm-project
#include "mlir/IR/PatternMatch.h"                 // from @llvm-project
#include "mlir/Interfaces/InferTypeOpInterface.h" // from @llvm-project
#include "mlir/Pass/Pass.h"                       // from @llvm-project
#include "mlir/Transforms/DialectConversion.h"    // from @llvm-project

#include <algorithm>
#include <iostream>
#include <map>
#include <string>
#include <utility>
#include <vector>

#include "src/utils/assert.h"
#include "src/utils/data_structure_utils.h"

#include "src/ir/cascade_ir.h"
#include "src/ir/kernel_ir.h"
#include "src/ir/schedule_ir.h"

using namespace std;

namespace mlir {
namespace utils {

/*
   0. Consumer/Producer/Block block index
   1. Operation               block index

   2. Consumer/Producer/Block slot index
   3. Operation               slot index

   4. Operation consuming/generating the value
   5. Consumer/Producer operation generating/consuming Value
      nullptr if Value is generated by a BlockAttribute
   6. Block generating Value
      nullptr if value is produced by an Op

   7. Value can be a OpResult or a Operand
   8. direction of connection
*/

enum connection_direction { operation_2_consumer, producer_2_operation };

enum producer_type { block_op, operation_op };

class connection {
public:
  connection() {}

  connection(unsigned external_slot_index, unsigned operation_slot_index,
             Operation *operation, Operation *external_operation,
             Block *block_external_operation, Value value,
             connection_direction direction) {
    this->external_slot_index = external_slot_index;
    this->operation_slot_index = operation_slot_index;
    this->operation = operation;
    this->external_operation = external_operation;
    this->block_external_operation = block_external_operation;
    this->value = value;
    this->direction = direction;
  }

  unsigned external_slot_index;
  unsigned operation_slot_index;

  Operation *operation;
  Operation *external_operation;
  Block *block_external_operation;

  Value value;

  connection_direction direction;

  producer_type is_producer_block_or_operation() {
    if (this->external_operation)
      return operation_op;
    else if (this->block_external_operation)
      return block_op;
    else
      ASSERT_COND((this->external_operation == nullptr) and
                      (this->block_external_operation == nullptr),
                  "dag.h::neitherblock or external producer");
  }
};

std::vector<connection> ExtractConsumers(Value v);
std::vector<connection> ExtractConsumers(Operation *i);
std::vector<connection> ExtractProducers(Operation *i);

template <class T>
inline std::vector<connection> ExtractConsumers_ofType(Operation *i) {
  std::vector<connection> conn = ExtractConsumers(i);
  std::vector<connection> conn_filtered;
  for (auto c : conn) {
    if (llvm::isa<T>(c.external_operation))
      conn_filtered.push_back(c);
  }
  return conn_filtered;
}

template <class T>
inline std::vector<connection> ExtractProducers_ofType(Operation *i) {
  std::vector<connection> prod = ExtractProducers(i);
  std::vector<connection> prod_filtered;
  for (auto p : prod) {
    if (p.is_producer_block_or_operation() == operation_op) {
      if (llvm::isa<T>(p.external_operation))
        prod_filtered.push_back(p);
    }
  }
  return prod_filtered;
}

llvm::iplist<Operation> &get_operations(Operation &op, bool &failure);

unsigned NpuRegion_NoofOperations(Operation *op);
unsigned NpuRegion_NoofKernels(Operation *op);
unsigned NpuRegion_NoofCascades(Operation *op);

NpuBlockType getOpBlockType(Operation *op);
NpuBlockType getBlockType(Operation *op);

bool consumed_only_by_dma_Op(::mlir::Value v);
bool produced_by_dma_Op(::mlir::Value v);

unsigned array_prod(ArrayRef<int64_t> s);
unsigned array_prod(SmallVector<int64_t, 4> s);
SmallVector<int64_t, 4> arrayref_2_smallvector(ArrayRef<int64_t> s);

void clone_scheduler_metadata(Value src, Value dst,
                              ::mlir::cascadeir::PlanType plan_type,
                              bool copy_storage_shape);

std::vector<double> getScale(Type t);
std::vector<int64_t> getZeroPoint(Type t);

float tensor_bandwidth(mlir::SchedTensorType t);
float tensor_size(mlir::SchedTensorType t, SmallVector<int64_t, 4> shape);

bool getIsSymmetric(Type t);
bool getIsPerChannel(Type t);
int32_t getNoBytesType(mlir::SchedTensorType t);
int32_t getBitDepthType(Type t);
bool getSigned(Type t);
value_datatype getDataType(Type t);
value_format getFormat(Type t);

uint64_t storage_size_for_sub_purpose(
    SchedTensorType t, mlir::ArchitectureConfig::ArchitectureConfigAttr arch_c,
    value_sub_purpose vsp, signed param_a = -1, signed param_b = -1);

FilterMetaData getScheduleIRFilter(Operation *op);

} // namespace utils
} // namespace mlir

#endif // IR_UTILS
